import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Solution515 {

    public List<Integer> largestValues(TreeNode root) {
        ArrayList<Integer> res = new ArrayList<>();
        this.bfs(Arrays.asList(root), res);
        return res;
    }

    public void bfs(List<TreeNode> nodes, List<Integer> res) {
        if (nodes.size() == 0) {
            return;
        }

        ArrayList<TreeNode> treeNodes = new ArrayList<>();
        Integer max = null;

        for (TreeNode node : nodes) {
            if (node == null) {
                continue;
            }
            if (max == null || node.val > max) {
                max = node.val;
            }
            treeNodes.add(node.left);
            treeNodes.add(node.right);
        }
        if (max != null) {
            res.add(max);
            bfs(treeNodes, res);
        }

    }

    public static void main(String[] args) {
    }
}
